#!/bin/bash

# update system
sudo -S apt-get update -y << EOF 
123456
EOF

# install dependencies
sudo apt-get upgrade -y
sudo apt-get install -y cmake g++ gcc git
sudo apt-get install -y swig python3-pip python3-dev portaudio19-dev libsndfile1 python3-setuptools


# install wiringOP-Python
cp -r /usr/src/wiringOP-Python/ ./
cd wiringOP-Python
python3 generate-bindings.py > bindings.i
sudo python3 setup.py install

cd ..

# install TakwayBoard
git clone http://43.132.157.186:3000/gaohz/TakwayBoard.git
cd TakwayBoard
sudo pip install -r requirements.txt
sudo pip install -v -e .

cd ..

# install wifi hotspot
sudo apt-get install -y hostapd dnsmasq

git clone http://43.132.157.186:3000/gaohz/wifi_hotpot.git
cd wifi_hotpot
sudo pip install flask psutil

# reboot
reboot
